using UnityEngine;
using Oxide.Core;
using System;
using System.Collections.Generic;
using Oxide.Core.Libraries.Covalence;
using System.Collections.ObjectModel;
namespace Oxide.Plugins
{
    [Info("CustomBoss", "531devv", "1.0.1", ResourceId = 531)]
    [Description("Spawn the creatures!")]

    class CustomBoss : HurtworldPlugin
    {
        DefaultConfig config;
        public static GameObject gameObject;
        static readonly DateTime epoch = new DateTime(2017, 1, 13, 17, 44, 0);
        static double CurrentTime() { return DateTime.UtcNow.Subtract(epoch).TotalSeconds; }

        #region Configuration

        #region Init
        void Init()
        {
            try
            {
                config = Config.ReadObject<DefaultConfig>();
            }
            catch

            {
                PrintWarning("Could not read config, creating new default config");
                LoadDefaultConfig();
            }

            try
            {
                StartTimer(); Puts("Stoper start!");
            }
            catch
            {
                PrintWarning("Stoper nie działa!");
            }
        }
        #endregion

        class DefaultConfig
        {
        }

        protected override void LoadDefaultConfig()
        {
            PrintWarning("Tworzenie nowego pliku konfiguracyjnegio.");
            Config.Clear();
            config = new DefaultConfig();
            Config.WriteObject(config, true);
            SaveConfig();
        }

        #endregion

        #region DataManager
        List<BossData> Datas = new List<BossData>();
        string editAreaName = null;
        BossData data;

        class BossData
        {
            private HashSet<string> received = new HashSet<string>();

            public string name { get; set; }
            public double timer { get; set; }

            public BossData() { }

            public void ClearReceived()
            {
                this.received.Clear();
            }

            public BossData(string name, double timer)
            {
                this.name = name;
                this.timer = timer;
            }

            public void RemoveReceived(string name)
            {
                this.received.Remove(name);
            }
        }

        private void LoadBossData()
        {
            var _Data = Interface.GetMod().DataFileSystem.ReadObject<Collection<BossData>>("BossData");
            foreach (var item in _Data)
            {
                Datas.Add(new BossData(
                        item.name,
                        item.timer
                    ));
            }
        }

        private void SaveBossData()
        {
            Interface.GetMod().DataFileSystem.WriteObject("BossData", Datas);
        }

        void Loaded()
        {
            SetTimer();
            LoadBossData();
        }

        #endregion

        #region Timers

        void SetTimer()
        {
            double date = CurrentTime() + 10800;
            Datas.Add(new BossData("Boss", date));
            SaveBossData();
        }

        void StartTimer()
        {
            timer.Repeat(1f, 0, () =>
            {
                CheckTime();
            });

            timer.Repeat(10800f, 0, () =>
            {
                timer.Once(7200, () =>
                {
                    Puts("1 hour remaining to spawn creatures");
				hurt.BroadcastChat(null, "<color=#6476e5>● <i>Została godzina do pojawienia się albinosów i kruków.</i></color>");
                });

                timer.Once(3600, () =>
                {
                    Puts("2 hour remaining to spawn creatures");
				hurt.BroadcastChat(null, "<color=#6476e5>● <i>Dwie godziny do pojawienia się albinosów i kruków.</i></color>");
                });
					SpawnObject("AITokarAlbinoServer", -3309, 198, -1544);
					SpawnObject("AITokarAlbinoServer", -3335, 198, -1486);

					// Jesień
					SpawnObject("AITokarAlbinoServer", -2387, 194, -848);
					SpawnObject("AITokarAlbinoServer", -2360, 197, -997);

					// Zima małe
					SpawnObject("AITokarAlbinoServer", -2627, 171, 1588);
					SpawnObject("AITokarAlbinoServer", -2640, 172, 1678);

					// Zima duże
					SpawnObject("AITokarAlbinoServer", -1227, 172, 1276);
					SpawnObject("AITokarAlbinoServer", -1238, 173, 1181);

					// Czer małe
					SpawnObject("AITokarAlbinoServer", 1488, 193, -1980);
					SpawnObject("AITokarAlbinoServer", 1445, 193, -1899);

					// Czer duże
					SpawnObject("AITokarAlbinoServer", 1091, 192, -3363);
					SpawnObject("AITokarAlbinoServer", 1194, 192, -3373);

					SpawnObject("AIRafagaServer", -3118, 272, -898);
					SpawnObject("AIRafagaServer", -3207, 273, -1065);
					SpawnObject("AIRafagaServer", -3100, 272,  -1060);

					SpawnObject("AIRafagaServer", -989, 272,  -2389);
					SpawnObject("AIRafagaServer", -907, 272,  -2414);
					SpawnObject("AIRafagaServer", -814, 272,  -2445);

					SpawnObject("AIRafagaServer", -3118, 285, -898);

                                        Puts("Albinosy i kruki zrespione.");
					hurt.BroadcastChat("<color=#6476e5>● <i>Albinosy i kruki właśnie się pojawiły!<i></color>");
					hurt.BroadcastChat("<color=#6476e5>● <i>Masz godzinę, zabij je i zdobądź łup!<i></color>");
            });
        }

        void CheckTime()
        {
            var _Data = Interface.GetMod().DataFileSystem.ReadObject<Collection<BossData>>("BossData");
            foreach (var item in _Data)
            {
                Datas.Add(new BossData(
                        item.name,
                        item.timer
                    ));
                double ct = CurrentTime();
                double cd = item.timer;
                double finish = cd - ct;
                int toInt = (int)finish;
                if (toInt == 0)
                {
                    Datas.Clear();
                    item.RemoveReceived("Boss");
                    item.ClearReceived();
                    SetTimer();
                    LoadDefaultConfig();
                }
            }

        }

        void GetTime(PlayerSession p)
        {

            var _Data = Interface.GetMod().DataFileSystem.ReadObject<Collection<BossData>>("BossData");
            foreach (var item in _Data)
            {
                Datas.Add(new BossData(
                        item.name,
                        item.timer
                    ));
                double ct = CurrentTime();
                double cd = item.timer;
                double finish = cd - ct;
                double remained = finish / 60;
                int toInt = (int)remained;
                hurt.SendChatMessage(p, null, toInt.ToString() + " minut.");
            }
        }
        #endregion

        #region Body
        public void SpawnObject(string monster, float x, float y, float z)
        {
            Vector3 position = new Vector3(x + Core.Random.Range(0, 2),
                    y + Core.Random.Range(0, 2),
                    z + Core.Random.Range(0, 1));
            RaycastHit hitInfo;
            Physics.Raycast(position, Vector3.down, out hitInfo);
            {
                Quaternion rotation = Quaternion.Euler(0.0f, (float)UnityEngine.Random.Range(0f, 360f), 0.0f);
                rotation = Quaternion.FromToRotation(Vector3.down, hitInfo.normal) * rotation;
                gameObject = Singleton<HNetworkManager>.Instance.NetInstantiate(monster, hitInfo.point, Quaternion.identity, GameManager.GetSceneTime());
                Destroy(gameObject);
            }
        }

        void Destroy(GameObject obj)
        {
            timer.Once(3600, () =>
            {
                Singleton<HNetworkManager>.Instance.NetDestroy(uLink.NetworkView.Get(obj));
                Puts("Tokary i kruki usunięte!");
            });
        }

        [ChatCommand("albino")]
        void cmdAlbino(PlayerSession p, string command, string[] args)
        {
            if (args.Length < 1)
            {
                hurt.SendChatMessage(p, null, "/albino czas");
                hurt.SendChatMessage(p, null, "/albino gdzie");
                if (p.IsAdmin == true)
                {
                    hurt.SendChatMessage(p, null, "/albino event");
                    return;
                }
                return;
            }
				
            if (args[0].Equals("czas"))
            {
                hurt.SendChatMessage(p, null, "Albinosy pojawią się za:");
                GetTime(p);
                return;
            }

            if (args[0].Equals("gdzie"))
            {
                hurt.SendChatMessage(p, null, "Albinosy pojawiają się na hangarach.");
                return;
            }

            if (p.IsAdmin == true)
            {
                if (args[0].Equals("event"))
                {
                    SpawnObject("AITokarAlbinoServer", -3309, 198, -1544);
                    SpawnObject("AITokarAlbinoServer", -3335, 198, -1486);

                    // Jesień
                    SpawnObject("AITokarAlbinoServer", -2387, 194, -848);
                    SpawnObject("AITokarAlbinoServer", -2360, 197, -997);

                    // Zima małe
                    SpawnObject("AITokarAlbinoServer", -2627, 171, 1588);
                    SpawnObject("AITokarAlbinoServer", -2640, 172, 1678);

                    // Zima duże
                    SpawnObject("AITokarAlbinoServer", -1227, 172, 1276);
                    SpawnObject("AITokarAlbinoServer", -1238, 173, 1181);

                    // Czer małe
                    SpawnObject("AITokarAlbinoServer", 1488, 193, -1980);
                    SpawnObject("AITokarAlbinoServer", 1445, 193, -1899);

                    // Czer duże
                    SpawnObject("AITokarAlbinoServer", 1091, 192, -3363);
                    SpawnObject("AITokarAlbinoServer", 1194, 192, -3373);

                    hurt.SendChatMessage(p, null, "<color=#6476e5>● <i>Event albinosy wystartował!</i></color>");
                    return;
                }
                return;
            }
            return;
        }

        [ChatCommand("kruki")]
        void cmdKruki(PlayerSession p, string command, string[] args)
        {
            if (args.Length < 1)
            {
                hurt.SendChatMessage(p, null, "/kruki czas");
                hurt.SendChatMessage(p, null, "/kruki gdzie");

                if (p.IsAdmin == true)
                {
                    hurt.SendChatMessage(p, null, "/kruki event");
                    return;
                }
                return;
            }
				
            if (args[0].Equals("czas"))
            {
                hurt.SendChatMessage(p, null, "Kruki pojawią się za:");
                GetTime(p);
                return;
            }

            if (args[0].Equals("gdzie"))
            {
                hurt.SendChatMessage(p, null, "Kruki pojawiają się na kuli.");
                return;
            }

            if (p.IsAdmin == true)
            {
                if (args[0].Equals("event"))
                {
                    SpawnObject("AIRafagaServer", -3118, 272, -898);
                    SpawnObject("AIRafagaServer", -3207, 273, -1065);
                    SpawnObject("AIRafagaServer", -3100, 272,  -1060);

                    SpawnObject("AIRafagaServer", -3171, 272, -1097);
                    SpawnObject("AIRafagaServer", -3041, 273, -931);

                    hurt.SendChatMessage(p, null, "<color=#6476e5>● <i>Event kruki wystartował!</i></color>");
                    return;
                }
                return;
            }
            return;
        }

        #endregion

        T GetConfig<T>(string name, T value) => Config[name] == null ? value : (T)Convert.ChangeType(Config[name], typeof(T));
    }
}